//########## AC-130

//### Sounds

datablock AudioProfile(gc_AircraftWarningStallSound)
{
  filename = "./aircraftwarning01.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_AircraftWarningDamageSound)
{
  filename = "./aircraftwarning02.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_AircraftWarningLockedSound)
{
  filename = "./aircraftwarning03.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_AC130EngineSound)
{
  filename = "./ac130engine.wav";
  description = AudioDefaultLooping3d;
  preload = true;
};

datablock AudioProfile(gc_AC130GatlingFireSound)
{
  filename = "./gatling.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_BTR60ShellImpactSound)
{
  filename = "./btr60impact.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_AC130CannonFireSound)
{
  filename = "./cannon.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_ExplosionSound)
{
  filename = "./explosion.wav";
  description = AudioDefault3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_AC130ContrailParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -10;
  spinRandomMax = 10;
  colors[0] = "1 1 1 0.5";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.5;
  sizes[1] = 0.5;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130ContrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 2;
  ejectionVelocity = 0;
  thetaMin = 0;
  thetaMax = 1;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130ContrailParticle";
};

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_TracerBigParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.9 0.4 0.5";
  colors[2] = "1 0.2 0.1 0.5";
  sizes[0] = 0.6;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_TracerBigEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_TracerBigParticle";
};

datablock ParticleData(gc_TracerVeryBigParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.9 0.4 0.5";
  colors[2] = "1 0.2 0.1 0.5";
  sizes[0] = 1.2;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_TracerVeryBigEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_TracerVeryBigParticle";
};

datablock ParticleData(gc_AC130GatlingFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.3 0.1 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130GatlingFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130GatlingFlashParticle";
};

datablock ParticleData(gc_AC130GatlingSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "0.1 0.05 0 0.3";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 2;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_AC130GatlingSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130GatlingSmokeParticle";
};

datablock ShapeBaseImageData(gc_AC130GatlingFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_AC130GatlingFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.05;
  stateEmitter[1] = gc_AC130GatlingSmokeEmitter; 
  stateEmitterTime[1] = 0.05;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_AC130GatlingFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_AC130CannonFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.3 0.1 0";
  sizes[0] = 10;
  sizes[1] = 6;
  sizes[2] = 4;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130CannonFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130CannonFlashParticle";
};

datablock ParticleData(gc_AC130CannonSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 800;
  lifetimeVarianceMS = 400;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 5;
  sizes[1] = 6;
  sizes[2] = 10;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_AC130CannonSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 60;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130CannonSmokeParticle";
};

datablock ShapeBaseImageData(gc_AC130CannonFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_AC130CannonFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.05;
  stateEmitter[1] = gc_AC130CannonSmokeEmitter; 
  stateEmitterTime[1] = 0.2;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_AC130CannonFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_AC130GatlingExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 0;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 2;
  sizes[1] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130GatlingExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130GatlingExplosionParticle";
};

datablock ParticleData(gc_AC130GatlingSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 0.5";
  colors[1] = "0 0 0 0";
  sizes[0] = 1;
  sizes[1] = 3;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_AC130GatlingSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 5;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130GatlingSmokeParticle";
};

datablock ExplosionData(gc_AC130GatlingExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_AC130GatlingExplosionEmitter;
  emitter[1] = gc_AC130GatlingSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 1;
  radiusDamage = 20;
  impulseRadius = 2;
  impulseForce = 20;
  soundProfile = gc_AC130GatlingImpactSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "5 5 5";
  camShakeDuration = 1;
  camShakeRadius = 2;
};

datablock ParticleData(gc_AC130CannonExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 50;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 25;
  sizes[1] = 15;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130CannonExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130CannonExplosionParticle";
};

datablock ParticleData(gc_AC130CannonSmokeParticle)
{
  dragCoefficient = 15;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3000;
  lifetimeVarianceMS = 1000;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 10;
  sizes[1] = 15;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_AC130CannonSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 100;
  velocityVariance = 100;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130CannonSmokeParticle";
};

datablock ExplosionData(gc_AC130CannonExplosion)
{
  lifeTimeMS = 200;
  emitter[0] = gc_AC130CannonExplosionEmitter;
  emitter[1] = gc_AC130CannonSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 20;
  lightEndRadius = 0;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
  damageRadius = 10;
  radiusDamage = 300;
  impulseRadius = 20;
  impulseForce = 300;
  soundProfile = gc_ExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "7 7 7";
  camShakeDuration = 3;
  camShakeRadius = 30;
};

datablock ParticleData(gc_AC130ExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 150;
  lifetimeVarianceMS = 50;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 25;
  sizes[1] = 15;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_AC130ExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130ExplosionParticle";
};

datablock ParticleData(gc_AC130SmokeParticle)
{
  dragCoefficient = 15;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3000;
  lifetimeVarianceMS = 1000;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 10;
  sizes[1] = 20;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_AC130SmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 100;
  velocityVariance = 100;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_AC130SmokeParticle";
};

datablock ExplosionData(gc_AC130Explosion : vehicleFinalExplosion)
{
  emitter[0] = gc_AC130ExplosionEmitter;
  emitter[1] = gc_AC130SmokeEmitter;
  uiName = "";
  debrisNum = 0;
  debrisNumVariance = 0;
};

datablock ProjectileData(gc_AC130ExplosionProjectile : vehicleFinalExplosionProjectile)
{
  uiName = "";
  explosion = gc_AC130Explosion;
};

//### Projectile

AddDamageType("gc_AC130",'\c0[AC-130 Spectre] %1','%2 \c0[AC-130 Spectre] %1',1,1);

datablock ProjectileData(gc_AC130GatlingProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 20;
  directDamageType = $DamageType::gc_AC130;
  radiusDamageType = $DamageType::gc_AC130;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 12;
  brickExplosionMaxVolumeFloating = 12;
  impactImpulse = 200;
  particleEmitter = gc_TracerBigEmitter;
  explosion = gc_AC130GatlingExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0;
};

datablock ProjectileData(gc_AC130CannonProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 500;
  directDamageType = $DamageType::gc_AC130;
  radiusDamageType = $DamageType::gc_AC130;
  brickExplosionRadius = 10;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 64;
  brickExplosionMaxVolumeFloating = 64;
  impactImpulse = 200;
  particleEmitter = gc_TracerVeryBigEmitter;
  explosion = gc_AC130CannonExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0;
};

//### Turret

datablock TSShapeConstructor(ac130gatlingDts)
{
  baseShape = "./ac130gatling.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./look.dsq look";
  sequence2 = "./spin.dsq spin";
};

datablock TSShapeConstructor(ac130cannonDts)
{
  baseShape = "./ac130cannon.dts";
  sequence0 = "./root_c.dsq root";
  sequence1 = "./look_c.dsq look";
};

datablock PlayerData(gc_AC130GatlingTurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./ac130gatling.dts";
  cameraMaxDist = 8;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = 0;
  maxLookAngle = 0.78;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 400;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = "2 2 2";
  crouchBoundingBox = "2 2 2";
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 1;
  lookDownLimit = 0;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  useEyePoint = 1;
};


datablock PlayerData(gc_AC130CannonTurretPlayer : gc_AC130GatlingTurretPlayer)
{
  shapeFile = "./ac130cannon.dts";
  uiName = "";
};

//### Vehicle

datablock WheeledVehicleTire(gc_AC130Tire)
{
  shapeFile = "";
  mass = 5;
  radius = 0.8;
  staticFriction = 1;
  kineticFriction = 1;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_AC130Spring)
{
  length = 0.4;
  force = 5000;
  damping = 500;
  antiSwayForce = 20;
};

datablock WheeledVehicleData(gc_AC130Vehicle)
{
  uiName = "AC-130 Spectre";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./ac130.dts";
  emap = true;
  minMountDist = 5;
  numMountPoints = 4;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  maxDamage = 200;
  destroyedLevel = 200;
  energyPerDamagePoint = 100;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 -1 -1";
  maxSteeringAngle = 1;
  integration = 4;
  tireEmitter = gc_TireEmitter;
  cameraRoll = false;
  cameraMaxDist = 20;
  cameraOffset = 6;
  cameraLag = 0;
  cameraDecay = 0.75;
  cameraTilt = 0.3;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = gc_AC130Tire;
  defaultSpring = gc_AC130Spring;
  flatTire = gc_AC130Tire;
  flatSpring = gc_AC130Spring;
  numWheels = 3;
  mass = 300;
  density = 5;
  drag = 1;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 1000;
  engineBrake = 100;
  brakeTorque = 2000;
  maxWheelSpeed = 30;
  rotationalDrag = 0.9;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  isSled = false;
  forwardThrust = 3000;
  reverseThrust = 1500;
  lift = 100;
  maxForwardVel = 50;
  maxReverseVel = 50;
  horizontalSurfaceForce = 200;
  verticalSurfaceForce = 100;
  autoInputDamping = 0.9;
  rollForce = 30000;
  yawForce = 30000;
  pitchForce = 20000;
  inputDamping = 0.9;
  stallSpeed = 15;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 1;
  lookDownLimit = 0;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "-5.5 2 1.2";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = gc_vehicleDamageEmitter;
  damageEmitterOffset[1] = "5.5 2 1.2";
  damageLevelTolerance[1] = 0.5;
  damageEmitter[2] = VehicleBurnEmitter;
  damageEmitterOffset[2] = "-5.5 2 1.2";
  damageLevelTolerance[2] = 0.8;
  damageEmitter[3] = VehicleBurnEmitter;
  damageEmitterOffset[3] = "5.5 2 1.2";
  damageLevelTolerance[3] = 0.8;
  numDmgEmitterAreas = 4;
  initialExplosionProjectile = gc_AC130ExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 5000;
  finalExplosionProjectile = gc_AC130ExplosionProjectile;
  finalExplosionOffset = 0;
  minRunOverSpeed = 2;
  runOverDamageScale = 5;
  runOverPushScale = 1.2;
  steeringUseStrafeSteering = false;
};

function gc_AC130Vehicle::onAdd(%this,%obj)
{
  parent::onAdd(%this,%obj);
  %obj.PlayAudio(0,gc_AC130EngineSound);
  %obj.damagewarning = 0;
  %obj.landinggear = 1;
  %obj.playThread(0,root);
  gc_AC130VehicleCheck(%obj);
  %t = new AIPlayer() { dataBlock = gc_AC130GatlingTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,2);
  %obj.turret1 = %t;
  %t = new AIPlayer() { dataBlock = gc_AC130CannonTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,3);
  %obj.turret2 = %t;
}

function gc_AC130Vehicle::onRemove(%this,%obj) { if(isObject(%obj.turret1)) { %obj.turret1.delete(); } if(isObject(%obj.turret2)) { %obj.turret2.delete(); } }

function gc_AC130VehicleCheck(%obj)
{
  if(!isObject(%obj)) return;
  %speed = mCeil(VectorLen(%obj.getVelocity()));
  schedule(500,0,"gc_AC130VehicleCheck",%obj);
  if(!isObject(%obj.getControllingObject())) return;
  %client = %obj.getControllingObject().client;
  %raycast = containerRayCast(%obj.getPosition(),VectorAdd(%obj.getPosition(),"0 0 -1000"),$TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::fxBrickObjectType | $TypeMasks::StaticObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ForceFieldObjectType,%obj);
  %col = firstWord(%raycast);
  %raypos = posFromRaycast(%raycast);
  %altitude = mCeil(getWord(%obj.getPosition(),2) - getWord(%raypos,2)); //mCeil(getWord(%obj.position,2) / 10);

  %V = MatrixMulVector(%obj.getSlotTransform(0),"1 0 0");
  %U = "2 0 0";
  %mag2 = VectorLen(%V);
  %dot = VectorDot(%V,%U);
  %result = %dot / (2*%mag2);
  %angle = mRadtoDeg(mACos(%result));
  if(getWord(%V,1) > 0) %angle = 360 - %angle;
  if(%speed < 20 && %altitude > 5) {
    %stall = "\c0STALL";
    %obj.PlayAudio(3,gc_AircraftWarningStallSound); }
  else
    %stall = "";

  if(%altitude <= 15)
  {
    if(%obj.landinggear == 0)
    {
      %obj.landinggear = 1;
      %obj.playThread(1,gearextend);
      for(%i=0;%i<%obj.getDatablock().numWheels;%i++) { %obj.schedule(1500,setWheelTire,%i,gc_AC130Tire); }
    }
  }
  else
  {
    if(%obj.landinggear == 1)
    {
      %obj.landinggear = 0;
      %obj.playThread(1,gearretract);
      for(%i=0;%i<%obj.getDatablock().numWheels;%i++) { %obj.setWheelTire(%i,emptyTire); }
    }
  }
  if(%speed < 10) %speed = "0" @ %speed;
  if(%speed < 100) %speed = "0" @ %speed;
  if(%altitude < 10) %altitude = "0" @ %altitude;
  if(%altitude < 100) %altitude = "0" @ %altitude;

  %warning = "";
  if(%obj.damagewarning > 0) {
    %obj.PlayAudio(1,gc_AircraftWarningDamageSound);
    %warning = "\c0WARNING";
    %obj.damagewarning--; }

  if(%obj.islocked) {
    %obj.PlayAudio(2,gc_AircraftWarningLockedSound);
    %obj.islocked = 0;
    %warning = "\c0LOCKED"; }
  %dmgstatus = "";
  if(%obj.getDamagePercent() > 0.3)
    %dmgstatus = "\c3MINOR DAMAGE";
  if(%obj.getDamagePercent() > 0.7)
    %dmgstatus = "\c0CRITICAL DAMAGE";
  if(%obj.landinggear == 1)
    %gear = "\c2GEAR";
  else
    %gear = "\c0GEAR";
  centerPrint(%client,"<font:Impact:24pt><just:center>\c2" @ mFloor(%angle) @ "\n<just:left>\c2SPD [ " @ %speed @ " ] <just:right>" @ %gear @ "\n<just:left>\c2ALT [ " @ %altitude @ " ]<just:center>" @ %stall @ "<just:right>\n<just:center>" @ %warning @ "<just:right>\n<just:center>\c2[        ]",1);
  bottomPrint(%client,"<font:Impact:24pt><just:center>" @ %dmgstatus,1,0);
}

function gc_AC130Vehicle::onImpact(%this,%obj,%data)
{
  if(%obj.destroyed) return;
  %speed = vectorLen(%obj.getVelocity());
  if(%speed > 20)
  {
    %p = new Projectile()
    {
      dataBlock = jeepFinalExplosionProjectile;
      initialVelocity = 0;
      initialPosition = %obj.getTransform();
      sourceObject = %obj;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
    %obj.setDamageLevel(%this.maxDamage);
    %obj.destroyed = 1;
    %obj.schedule(10,"finalExplosion");
    %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
    %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
  }
}

package gc_AC130Package
{
  function gc_AC130Vehicle::Damage(%this,%obj,%source,%pos,%amount,%type)
  {
    if(%amount > 0) %obj.damagewarning = 6;
    parent::Damage(%this,%obj,%source,%pos,%amount,%type);
  }
  function Armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_AC130GatlingLoop);
      if(!%val) cancel(%obj.gc_AC130CannonLoop);
      if(%mount.getDataBlock() == gc_AC130GatlingTurretPlayer.getId() && %triggerNum == 0 && %val)
        if(getSimTime() - %obj.lastShotTime > 100) { %obj.gc_AC130GatlingFire(%val); %obj.lastShotTime = getSimTime(); }
      if(%mount.getDataBlock() == gc_AC130CannonTurretPlayer.getId() && %triggerNum == 0 && %val)
        if(getSimTime() - %obj.lastShotTime > 4000) { %obj.gc_AC130CannonFire(%val); %obj.lastShotTime = getSimTime(); }
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_AC130GatlingFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_AC130GatlingLoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_AC130GatlingLoop);  return; }
    if(%obj.getObjectMount().getDataBlock() != gc_AC130GatlingTurretPlayer.getId()) { cancel(%obj.gc_AC130GatlingLoop); return; }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_AC130GatlingProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006)),VectorScale(%mount.getMuzzleVector(1),200));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_AC130GatlingFireImage,1);
    %mount.playThread(1,spin);
    serverPlay3D(gc_AC130GatlingFireSound,%obj.getPosition());
    %obj.gc_AC130GatlingLoop = %obj.schedule(75,gc_AC130GatlingFire,%val);
    return;
  }
  function Player::gc_AC130CannonFire(%obj,%val)
  {
    if(!isObject(%obj.getObjectMount())) return;
    if(%obj.getObjectMount().getDataBlock() != gc_AC130CannonTurretPlayer.getId()) return;
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_AC130CannonProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006)),VectorScale(%mount.getMuzzleVector(1),200));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_AC130CannonFireImage,1);
    serverPlay3D(gc_AC130CannonFireSound,%obj.getPosition());
    return;
  }
};
activatepackage(gc_AC130Package);
